from dataclasses import dataclass, asdict


@dataclass
class Paper(object):
    """
    Paper is a research paper:
    . title: Title of the paper
    . citations: Number of citations recorded by Google Scholar
    . pub_year: The year the paper was published
    """

    title: str
    citations: int
    pub_year: int

    def to_dict(self):
        return asdict(self)
