import os
import random
import time

from typing import Dict

HEADER = {
    "authority": "scholar.google.ca",
    "method": "GET",
    "scheme": "https",
    "accept": "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3",
    "accept-encoding": "gzip, deflate, br",
    "accept-language": "en-CA,en;q=0.9,es-PE;q=0.8,es;q=0.7,en-GB;q=0.6,en-US;q=0.5",
    "cache-control": "max-age=0",
    "referer": "https://scholar.google.ca/scholar",
    "upgrade-insecure-requests": "1",
}

def delay():
    """
    Will pause the main thread of operation.
    """
    second = random.choice(range(15))
    time.sleep(second)


def headers_rand_user_agent() -> Dict[str, str]:
    """
    Identification spoofing (cloaking), selecting random user-agents.
    """
    headers = HEADER
    headers["user_agents"] = random_user_agent()
    return headers


def random_user_agent() -> str:
    """
    Selects a random user-agent from user_agents.txt
    """
    path = os.path.join(os.path.dirname(__file__), "user_agents.txt")
    with open(path) as infile:
        lines = infile.readlines()
    return random.choice(lines).strip()
